function varargout = design_eme545(varargin)
% DESIGN_EME545 MATLAB code for design_eme545.fig
%      DESIGN_EME545, by itself, creates a new DESIGN_EME545 or raises the existing
%      singleton*.
%
%      H = DESIGN_EME545 returns the handle to a new DESIGN_EME545 or the handle to
%      the existing singleton*.
%
%      DESIGN_EME545('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DESIGN_EME545.M with the given input arguments.
%
%      DESIGN_EME545('Property','Value',...) creates a new DESIGN_EME545 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before design_eme545_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to design_eme545_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help design_eme545

% Last Modified by GUIDE v2.5 12-Apr-2013 14:32:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @design_eme545_OpeningFcn, ...
    'gui_OutputFcn',  @design_eme545_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%--------------------------------------------------------
% --- Executes just before design_eme545 is made visible.
function design_eme545_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to design_eme545 (see VARARGIN)

% Choose default command line output for design_eme545
handles.output = hObject;

data.state       = 'pause';
data.addOffset   = false;
data.readMatFile = false;
data.sample      = 1;
data.isVibrationIsolationOn = 0;
data.emptyCabinMass = 40*10^3;
data.numberOfPassengers = 15;
data.massPerPassengerInKg = 80;
data.springK=9000;
data.zeta=0.7;
data.speed=1;
data.w1=0;
data.totalMass = data.emptyCabinMass + data.numberOfPassengers*data.massPerPassengerInKg;
data.cabAbsoluteAcc = 0;


set(handles.figure1, 'UserData',data);
set(handles.figure1,'Name','Ver. 3/31/13. Team #4. Vibration isolation. UW Madison, EME 545, spring 2013');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes design_eme545 wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%--------------------------------------------------------
% --- Outputs from this function are returned to the command line.
function varargout = design_eme545_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%--------------------------------------------------------
% % --- Executes on slider movement.
% function emptyCabMass_Callback(hObject, eventdata, handles)
% % hObject    handle to emptyCabMass (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
%
% % Hints: get(hObject,'Value') returns position of slider
% %        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
%
% data = get(handles.figure1, 'UserData');
% data.emptyCabMass = round(get(hObject,'Value')*10^(2))/10^(2);
% set(handles.emptyCabMassInKgText,'String', num2str(data.emptyCabMass),'HorizontalAlignment','left');
% data.emptyCabMass = data.emptyCabMass*10^3;
% data.totalMass = data.emptyCabinMass + data.numberOfPassengers*data.massPerPassengerInKg;
% set(handles.figure1, 'UserData',data);
%
%
% % --- Executes during object creation, after setting all properties.
% function emptyCabMass_CreateFcn(hObject, eventdata, handles)
% % hObject    handle to emptyCabMass (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    empty - handles not created until after all CreateFcns called
%
% % Hint: slider controls usually have a light gray background.
% if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor',[.9 .9 .9]);
% end

%--------------------------------------------------------
% --- Executes on slider movement.
function numberOfPassengers_Callback(hObject, eventdata, handles)
% hObject    handle to numberOfPassengers (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

data = get(handles.figure1, 'UserData');
if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.resetButton);
    set(handles.figure1, 'UserData',data);
else

data.numberOfPassengers = round(get(hObject,'Value'));
set(handles.numberOfPassengersText,'String', num2str(data.numberOfPassengers),'HorizontalAlignment','left');
data.totalMass = data.emptyCabinMass + data.numberOfPassengers*data.massPerPassengerInKg;

data = updateSolution(data);
update_plots(data,handles);
updateInfoPanel(handles,data);
set(handles.figure1, 'UserData',data);
end

%--------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function numberOfPassengers_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numberOfPassengers (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%--------------------------------------------------------
% --- Executes on slider movement.
function massPerPassengerInKg_Callback(hObject, eventdata, handles)
% hObject    handle to massPerPassengerInKg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

data = get(handles.figure1, 'UserData');

if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.resetButton);
    set(handles.figure1, 'UserData',data);
else
data.massPerPassengerInKg = round(get(hObject,'Value'));
set(handles.massPerPassengerText,'String', num2str(data.massPerPassengerInKg),'HorizontalAlignment','left');
data.totalMass = data.emptyCabinMass + data.numberOfPassengers*data.massPerPassengerInKg;

data = updateSolution(data);

update_plots(data,handles);
updateInfoPanel(handles,data);
set(handles.figure1, 'UserData',data);
end

%--------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function massPerPassengerInKg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to massPerPassengerInKg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%--------------------------------------------------------
% --- Executes on slider movement.
function criticalStiffnessRatio_Callback(hObject, eventdata, handles)
% hObject    handle to criticalStiffnessRatio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

data = get(handles.figure1, 'UserData');

if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.resetButton);
    set(handles.figure1, 'UserData',data);
else

data.zeta =  round(get(hObject,'Value')*10^(3))/10^(3);
set(handles.criticalStiffnessRatioText,'String', num2str(data.zeta),'HorizontalAlignment','left');

data = updateSolution(data);

update_plots(data,handles);
updateInfoPanel(handles,data);
set(handles.figure1, 'UserData',data);
end
%--------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function criticalStiffnessRatio_CreateFcn(hObject, eventdata, handles)
% hObject    handle to criticalStiffnessRatio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%--------------------------------------------------------
% --- Executes on slider movement.
function springK_Callback(hObject, eventdata, handles)
% hObject    handle to springK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

data = get(handles.figure1, 'UserData');

if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.resetButton);
    set(handles.figure1, 'UserData',data);
else

data.springK =   round(get(hObject,'Value'));
set(handles.springKText,'String', num2str(data.springK),'HorizontalAlignment','left');
data.springK =   data.springK;

data = updateSolution(data);
update_plots(data,handles);
updateInfoPanel(handles,data);
set(handles.figure1, 'UserData',data);
end
%--------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function springK_CreateFcn(hObject, eventdata, handles)
% hObject    handle to springK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%--------------------------------------------------------
% --- Executes on slider movement.
function emptyCabinMass_Callback(hObject, eventdata, handles)
% hObject    handle to emptyCabinMass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

data = get(handles.figure1, 'UserData');


if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.resetButton);
    set(handles.figure1, 'UserData',data);
else
data.emptyCabinMass =   round(get(hObject,'Value'));
set(handles.emptyCabMassInKgText,'String', num2str(data.emptyCabinMass),'HorizontalAlignment','left');
data.emptyCabinMass=data.emptyCabinMass*10^3;
data.totalMass = data.emptyCabinMass + data.numberOfPassengers*data.massPerPassengerInKg;

data = updateSolution(data);

update_plots(data,handles);
updateInfoPanel(handles,data);
set(handles.figure1, 'UserData',data);
end

%--------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function emptyCabinMass_CreateFcn(hObject, eventdata, handles)
% hObject    handle to emptyCabinMass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%--------------------------------------------------------
% --- Executes on button press in runButton.
function runButton_Callback(hObject, eventdata, handles)
% hObject    handle to runButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.figure1, 'UserData');
if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.runButton);
    data.state = 'reset';
    set(handles.figure1, 'UserData',data);
    return;
else
    if strcmp(data.state,'step')
        data.state = 'stop';
    else
        data.state = 'running';
    end
    
    if  data.sample >= data.numberOfSamples
        data.sample    = 1;
    end
    set(handles.figure1, 'UserData',data);
end

moreToDo = true;

while moreToDo
    
    updatePlotWithVibrationIsolation(handles,data.sample,data);
    update_plots(data,handles);
    
    data = get(handles.figure1, 'UserData');
    data.sample = data.sample + data.speed;
    set(handles.figure1, 'UserData',data);
    if not(strcmp(data.state,'running'))
        break;
    end
    if data.sample >=  data.numberOfSamples || data.sample+data.speed>data.numberOfSamples
        moreToDo = false;
        data.sample = data.numberOfSamples;
        set(handles.figure1, 'UserData',data);
    end
end

%--------------------------------------------------------
% --- Executes on button press in stopButton.
function stopButton_Callback(hObject, eventdata, handles)
% hObject    handle to stopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.figure1, 'UserData');
data.state = 'stop';
set(handles.figure1, 'UserData',data);
%--------------------------------------------------------
% --- Executes on button press in stepButton.
function stepButton_Callback(hObject, eventdata, handles)
% hObject    handle to stepButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.figure1, 'UserData');

if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.stepButton);
    data.state = 'reset';
    set(handles.figure1, 'UserData',data);
else
    data.state = 'step';
    set(handles.figure1, 'UserData',data);
    runButton_Callback(hObject, eventdata, handles);
end
%--------------------------------------------------------
% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data        = get(handles.figure1, 'UserData');
data.state = 'reset';
data.sample = 1;

if not(data.readMatFile)
    uiwait(errordlg('Must load the mat file first!','Bad Input', 'modal'));
    uicontrol(handles.resetButton);
    set(handles.figure1, 'UserData',data);
else
    data.w1     = 3;
    data.sample = 1;
    springcoord( [0.5*data.w1 data.h1Min] , [ 0.5*data.w1 data.h1Max ], 8, 1*data.h1Max, data.h1Max/20);
    updatePlotWithVibrationIsolation(handles,data.sample,data);
    update_plots(data,handles);
    set(handles.figure1, 'UserData',data);
    %runButton_Callback(hObject, eventdata, handles);
end

%--------------------------------------------------------
% --- Executes on slider movement.
function simulationSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to simulationSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

data        = get(handles.figure1, 'UserData');
data.speed  = round(get(hObject,'Value'));
set(handles.figure1, 'UserData',data);

%--------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function simulationSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to simulationSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%=====================================================
% --- Executes on button press in loadMatFile.
function loadMatFile_Callback(hObject, eventdata, handles)
% hObject    handle to loadMatFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.figure1, 'UserData');

set(0,'CurrentFigure',handles.figure1);
[fileName,pathName] = uigetfile('*.mat','Select mat file');
if fileName==0
    data.readMatFile=false;
    uiwait(warndlg('No mat file loaded!',...
        'Bad Input', 'modal'));
    uicontrol(handles.loadMatFile);
else
    
    data.readMatFile=true;
    set(handles.matFileNameText,'String',fileName,'HorizontalAlignment','left');
    accData = load( fullfile(pathName,fileName) );
    
    data.accTurbData     = accData.a_turb;
    data.accNominalData  = accData.a_smooth;
    
    data.numberOfSamples = length(accData.ts);
    data.sample          = 1;
    data.state           = 'reset';
    data.ts              = accData.ts;
    data.fundFreq        = 2*pi/(data.numberOfSamples * data.ts(2));
    
    %find absolute position of airplane during turbulent flight
    [D,ws] = fft_easy( data.accTurbData,data.ts);
    D = -1 * D./(ws.^2);
    D(1) = 0;
    data.absolutePositionAirplaneTubulent = ifft_easy(D,ws);   
    
    data = updateSolution(data);
    
    data.w1=3;
    
    update_plots(data,handles);
    updateInfoPanel(handles,data);
    set(handles.figure1, 'CurrentAxes',handles.simulationAxes);
    cla(handles.simulationAxes);
    springcoord( [0.55*data.w1 data.h1Min-0.5*abs(data.h1Min)] , [ 0.55*data.w1 data.h1Max ], 8, 1*data.h1Max, data.h1Max/20);
    
    %make initial plots
    updatePlotWithVibrationIsolation(handles,1,data);    
end

set(handles.figure1, 'UserData',data);

%--------------------------------------------------------
function data = updateSolution(data)


I=sqrt(-1);
c=data.zeta*2*sqrt(data.springK*data.totalMass);

%find the FFT of the displacement of first class during nominal flight
[data.nominalSolution,ws] = make_X(data.accNominalData(:),data.ts(2),data.totalMass,data.springK,c);

%now do IFFT to obtain the absolute displacement of first class in time domain, and normalize
data.nominalSolution      = ifft_easy(data.nominalSolution,ws );
data.nominalSolution      = data.nominalSolution-mean( data.nominalSolution);

%find the FFT of the displacement of first class during turbalant flight
[data.turbSolution,ws] = make_X(data.accTurbData(:),data.ts(2),data.totalMass,data.springK,c);

%find the absolute acceleration of first class during turbelant
data.cabAbsoluteAcc    = ifft_easy(-ws.^2 .* data.turbSolution,ws );

%find the absolute displacement of first class during turbalant
data.turbSolution      = ifft_easy(data.turbSolution,ws );
data.turbSolution      = data.turbSolution-mean(data.turbSolution);

data.h1Max = max([data.turbSolution; data.nominalSolution]);
data.h1Min = min([data.turbSolution; data.nominalSolution]);


%--------------------------------------------------------
function update_plots(data,handles)
ext_ = 12;  
set(handles.figure1, 'CurrentAxes',handles.vibrationActiveAxes);
cla;

hold(handles.vibrationActiveAxes,'on');
plot(data.ts, data.absolutePositionAirplaneTubulent,'r');

if data.addOffset
   plot(data.ts,data.turbSolution+ext_,'b');
   legend('airplane','1st class','Location', 'NorthEast');
   plot(data.ts(data.sample),data.turbSolution(data.sample)+ext_,'r.');  
   ylim([-8 30]); 
else
   plot(data.ts,data.turbSolution,'b');
   legend('airplane','1st class','Location', 'NorthEast');    
   plot(data.ts(data.sample),data.turbSolution(data.sample),'r.');
   ylim([-5 15]);
end
plot(data.ts(data.sample),data.absolutePositionAirplaneTubulent(data.sample),'b.')
grid on;

hold(handles.vibrationActiveAxes,'off');
set(handles.figure1, 'CurrentAxes',handles.trAxes);
cla;
r   = linspace(0,5, 20);
tmp = (2*r*data.zeta).^2;
y   = sqrt(1+tmp)./sqrt(  (1-r.^2).^2 + tmp );
plot(r,y,'r');
ylim([0 3]);
title('transmissibility');
xlabel('r ratio');
ylabel('TR');
grid(handles.trAxes,'on');

theMin=min(data.accTurbData-mean(data.accTurbData));
theMax=max(data.accTurbData-mean(data.accTurbData));

set(handles.figure1, 'CurrentAxes',handles.firstClassVsRestAxes);
cla;
hold(handles.firstClassVsRestAxes,'on');
plot(data.ts,data.accTurbData,'r');
plot(data.ts,data.cabAbsoluteAcc,'b');
%plot(data.ts,data.accNominalData,'k');

plot([data.ts(data.sample) data.ts(data.sample)],[-5 15],'m-.');
%legend('rest of airplane','first class','nominal','time','Location', 'East');
legend('rest of airplane','first class','time','Location', 'East');

%--------------------------------------------------------
function  updatePlotWithVibrationIsolation(handles,i,data)
ext_ = 12;
h_   = 0.1*abs(data.h1Max);

springcoord( [0.55*data.w1 data.h1Min-0.5*abs(data.h1Min)] , [ 0.55*data.w1 data.h1Max ],...
    8, 20, 1);
    
set(handles.figure1, 'CurrentAxes',handles.simulationAxes);
cla;

set(handles.flightInformation,'String',...
    sprintf('sample [%d] time [%3.3f] sec',i,data.ts(i)));


%------- plot rest of airplane position during turbulent flight -----% 
plot([-data.w1 data.w1],[0 0 ],'r:');

rectangle('Position',[-0.75*data.w1,data.absolutePositionAirplaneTubulent(i),1.5*data.w1,h_],...
    'Curvature',0.4,...
    'LineWidth',1.4,'LineStyle','-','FaceColor',[1 0 0],...
    'EdgeColor','r');

hold(handles.simulationAxes,'on');
text(0.8*data.w1,data.absolutePositionAirplaneTubulent(i),'airplane','FontSize',7);

rectangle('Position',[-0.45*data.w1,data.turbSolution(i)+ext_,0.9*data.w1, h_],...
    'Curvature',0.4,...
    'LineWidth',1.4,'LineStyle','-','FaceColor',[0 .1 1],...
    'EdgeColor','r');

text(0.5*data.w1,data.turbSolution(i)+ext_,'1st class','FontSize',7);
    
h=quiver(0,data.absolutePositionAirplaneTubulent(i)-5,...
    0,4.5,'autoscale','off'); %,0,0.2*abs(data.h1Max));
adjust_quiver_arrowhead_size(h, 5);
text(0.05*data.w1,data.absolutePositionAirplaneTubulent(i)-3.5,...
    sprintf('%0.3E %s',data.accTurbData(i)*data.totalMass,'N'),'FontSize',8);

%---------------------%
[x,yNoisy]=springcoord( [0.25*data.w1 data.absolutePositionAirplaneTubulent(i)+h_],...
    [0.25*data.w1  data.turbSolution(i)+ext_]);

line(real(x),yNoisy);

line([-.25*data.w1 -.25*data.w1    -0.4*data.w1     -0.1*data.w1 ],...
    [data.absolutePositionAirplaneTubulent(i)+h_ data.absolutePositionAirplaneTubulent(i)+h_+1,...
    data.absolutePositionAirplaneTubulent(i)+h_+1   data.absolutePositionAirplaneTubulent(i)+h_+1]);

line([-0.4*data.w1 -0.4*data.w1],...
    [data.absolutePositionAirplaneTubulent(i)+h_+1 data.absolutePositionAirplaneTubulent(i)+h_+2]);

line([-0.1*data.w1 -0.1*data.w1],...
    [data.absolutePositionAirplaneTubulent(i)+h_+1 data.absolutePositionAirplaneTubulent(i)+h_+2]);

line([-0.25*data.w1 -0.25*data.w1],...
    [data.absolutePositionAirplaneTubulent(i)+h_+1.5 data.turbSolution(i)+ext_+h_]);


xlim([-data.w1 1.3*data.w1]);
ylim([-8 30]);
%

drawnow;

%--------------------------------------------------------
function updateInfoPanel(handles,data)

wn = sqrt(data.springK/data.totalMass);

set(handles.totalMassInfoTag,'String',num2str(data.totalMass));
set(handles.turbW1Tag,'String',num2str(data.fundFreq/(2*pi)));
set(handles.cInfoTag,'String',num2str(2*data.zeta*data.totalMass*wn));
set(handles.wnInfoTag,'String',num2str(wn/(2*pi)));
set(handles.sampleTimeInfoTag,'String',num2str(data.ts(2) ));
set(handles.numberSampleInfoTag,'String',num2str(data.numberOfSamples ));
set(handles.flightTimeInfoTag,'String',num2str(data.ts(2)*(data.numberOfSamples-1)));

drawnow;


%--------------------------------------------------------
function [ xvec, yvec ] = springcoord( pt1, pt2, varargin)
% SPRINGCOORD   Returns the coordinates for a spring starting at pt1 and
%   ends at pt2. Maximum length 'rmax', number of coils 'n', and offset of
%   the spring from the two ends 'd' are used to size the spring display
%   automatically.
%
%  Usage:
%  MUST first initialize the spring
%     [ xvec, yvec ] = springcoord( [ x1 y1 ] , [ x2 y2 ], n, rmax, d)
%  Stretch and compress the spring with new coordinates
%     [ xvec, yvec ] = springcoord( [ x1new y1new ] , [ x2new y2new ])
%
%  Diagram:
%      |<-- d -->|<----- n*h ------>|<-- d -->|
%      ___________/\  /\  /\  /\  /\___________
%   (x1,y1)         \/  \/  \/  \/          (x2,y2)
%
%   *h is the 2D longitudinal length of a single coil at the current
%    configration.
%
%  Tips: This function sizes the spring such that the spring becomes a
%       a single line at the maximum stretch length. You can make rmax
%       slightly larger than the actual maximum length to retain the shape.
%       To plot the spring, simply use plot(xvec,yvec).
%
%  Version 0.1a
%  Created by Dan Peng, 9/6/2010

% Initialize variables
persistent c d n
% Debug note: persistant variables are cleared whenever the .m file
%             is edited.

if nargin > 2
    n = varargin{1}; rmax = varargin{2};  d = varargin{3};
    smax = rmax - 2*d;       % Maximum length of the spring portion
    hmax = smax/n;           % Maximum 2D longitudinal length
    c = hmax/4;              % 2D length of the quarter coil.
else
    if isempty(c)
        disp('Please first initialized the spring');
        xvec = NaN; yvec = NaN;
        return
    end
end

s = norm(pt2-pt1) - 2*d; % Current length of the spring portion
h = s/n;                 % Current 2D longitudional length of single coil

% Calculate the spring coordinates along an unrotated x axis

pp = 0:(2*n-1);                       % Switches yoffset between +/-1
ypts = [ 0 0 (-ones(1,2*n)).^pp 0 0];
yscaler = sqrt(c^2-(h/4)^2);          % "Pitch" height
ypts = yscaler*ypts;

xpts = linspace(0,s,length(ypts)-2);
xpts = [ 0 d+xpts 2*d+xpts(end) ];    % Accounting for offsets

% Rotation matrix: R = [ e1 ; e2 ]
%                    = [ cos(th) -sin(th);
%                        sin(th)  cos(th ]
%
% Example on obtaining unit vector e1:
%   r = (pt2 - pt1)
%     = [ x2 ; y2 ] - [ x1 ; y1 ]
%     = [ x ; y ]
%
%   Then [ x ; y ]/norm(r) is effectively
%   [ adj/hyp ; opp/hyp ] or [ cos(th) ; sin(th) ]

e1 = (pt2 - pt1)'/norm(pt2-pt1); % Rotated unit vector e1
e2 = [ -e1(2); e1(1) ];          % Rotated unit vector e2

% Multiply the unrotated points by the rotation matrix.
xvec = pt1(1) + e1(1)*xpts + e2(1)*ypts;
yvec = pt1(2) + e1(2)*xpts + e2(2)*ypts;


%--------------------------------------------
function update(figure,the_axes,data,the_data)

set(figure, 'CurrentAxes',the_axes);
cla(the_axes);
plot(the_axes,data.ts,the_data);
%ylim([data.minY data.maxY ]);

%--------------------------------------------


function adjust_quiver_arrowhead_size(quivergroup_handle, scaling_factor)
% Make quiver arrowheads bigger or smaller.
%
% adjust_quiver_arrowhead_size(quivergroup_handle, scaling_factor)
%
% Example:
%   h = quiver(1:100, 1:100, randn(100, 100), randn(100, 100));
%   adjust_quiver_arrowhead_size(h, 1.5);   % Makes all arrowheads 50% bigger.
%
% Inputs:
%   quivergroup_handle      Handle returned by "quiver" command.
%   scaling_factor          Factor by which to shrink/grow arrowheads.
%
% Output: none

% Kevin J. Delaney
% December 21, 2011
% BMT Scientific Marine Services (www.scimar.com)

if ~exist('quivergroup_handle', 'var')
    help(mfilename);
    return
end

if isempty(quivergroup_handle) || any(~ishandle(quivergroup_handle))
    errordlg('Input "quivergroup_handle" is empty or contains invalid handles.', ...
        mfilename);
    return
end

if length(quivergroup_handle) > 1
    errordlg('Expected "quivergroup_handle" to be a single handle.', mfilename);
    return
end

if ~strcmpi(get(quivergroup_handle, 'Type'), 'hggroup')
    errrodlg('Input "quivergroup_handle" is not of type "hggroup".', mfilename);
    return
end

if ~exist('scaling_factor', 'var') || ...
        isempty(scaling_factor) || ...
        ~isnumeric(scaling_factor)
    errordlg('Input "scaling_factor" is missing, empty or non-numeric.', ...
        mfilename);
    return
end

if length(scaling_factor) > 1
    errordlg('Expected "scaling_factor" to be a scalar.', mfilename);
    return
end

if scaling_factor <= 0
    errordlg('"Scaling_factor" should be > 0.', mfilename);
    return
end

line_handles = get(quivergroup_handle, 'Children');

if isempty(line_handles) || (length(line_handles) < 3) || ...
        ~ishandle(line_handles(2)) || ~strcmpi(get(line_handles(2), 'Type'), 'line')
    errordlg('Unable to adjust arrowheads.', mfilename);
    return
end

arrowhead_line = line_handles(2);

XData = get(arrowhead_line, 'XData');
YData = get(arrowhead_line, 'YData');

if isempty(XData) || isempty(YData)
    return
end

%   Break up XData, YData into triplets separated by NaNs.
first_nan_index = find(~isnan(XData), 1, 'first');
last_nan_index  = find(~isnan(XData), 1, 'last');

for index = first_nan_index : 4 : last_nan_index
    these_indices = index + (0:2);
    
    if these_indices(end) > length(XData)
        break
    end
    
    x_triplet = XData(these_indices);
    y_triplet = YData(these_indices);
    
    if any(isnan(x_triplet)) || any(isnan(y_triplet))
        continue
    end
    
    %   First pair.
    delta_x = diff(x_triplet(1:2));
    delta_y = diff(y_triplet(1:2));
    x_triplet(1) = x_triplet(2) - (delta_x * scaling_factor);
    y_triplet(1) = y_triplet(2) - (delta_y * scaling_factor);
    
    %   Second pair.
    delta_x = diff(x_triplet(2:3));
    delta_y = diff(y_triplet(2:3));
    x_triplet(3) = x_triplet(2) + (delta_x * scaling_factor);
    y_triplet(3) = y_triplet(2) + (delta_y * scaling_factor);
    
    XData(these_indices) = x_triplet;
    YData(these_indices) = y_triplet;
end

set(arrowhead_line, 'XData', XData, 'YData', YData);



%-------------------------------------------------
%takes acceleration data and returns the FFT of the displacement
function [X_dft,ws] = make_X(acc_data,delT,m,k,c)

[D,ws] = fft_easy(acc_data,delT);
I      = sqrt(-1);
X_dft  = (c*D./(I*ws) +  k*D./( - ws.^2) )./ ( ( -m* ws.^2 + I*ws*c + k) );
X_dft(1) = 0;

%-------------------------------------------------
function [xt,ts] = ifft_easy(Xfft,ws,varargin);
% [xt,ts] = ifft_easy(Xfft,ws,DIM);
% 
% This m-file is the inverse of fft_easy.  It takes the inverse FFT of the
% complex FFT "Xfft" (produced by fft_easy) and returns the time record and
% corresponding time vector.  This is accomplished by mirroring the complex
% conjugates of the coefficients in Xfft and then using 'ifft.m'.
%   Xfft - FFT or array of FFTs.  If Xfft is a matrix,
%        the FFT operates on the larger dimension of Xfft, unless the
%        optional argument DIM is given.
%   DIM - (optional) the dimension over which the FFT acts
%   ws - frequency vector
% 
% If no output arguments are specified, a plot of the time history(ies) is
% created in a new figure window.
%
% This routine assumes that Xfft has not been scaled after applying
% 'fft_easy'.
%
% Matt Allen, Spring 2005
% msalle@sandia.gov

w1 = ws(2)-ws(1);

if nargin > 2
    DIM = varargin{1};
    if DIM == 2;
        Xfft = Xfft.';
    end
else
    [a,b] = size(Xfft);
    if b > a;
        Xfft = Xfft.';
    end
end

% The time sequences are now the columns of xt.
L = size(Xfft,1);
if length(ws) ~= L;
    warning('Frequency Vector should be the same length as FFT sequence');
end

N = 2*(L-1);
xt = ifft([Xfft; conj(Xfft([(end-1):-1:2],:))],[],1);
    %norm(imag(xt))/norm(real(xt))
xt = real(xt);

T = 2*pi/w1;
ts = [0:T/N:T-T/N];

if nargout < 1;
    figure
    plot(ts,xt); grid on;
    title('IFFT(x)');
    xlabel('Time (s)'); ylabel('x(t)');
end
    

%-------------------------------------------------
function [Xfft,ws] = fft_easy(xt,ts,varargin)
% [Xfft ws] = fft_easy(xt,ts,DIM);
% 
% Function which takes the FFT of the real time sequence "xt" and
% returns the FFT for positive frequencies and the corresponding
% frequency vector in radians per second. (rad/s).
%   xt - sampled time response or array of time responses.  If xt is a matrix,
%        the FFT operates on the larger dimension of xt, unless the
%        optional argument DIM is given.
%   ts - Time between samples or vector of equally spaced time samples.
% Optional Arguments:
%   DIM - (optional) the dimension over which the FFT acts (1 or 2D only)
% Output Arguments:
%   Xfft - complex FFT coefficients of xt.
%   ws - frequency vector corresponding to Xfft in rad/s.
% If no output arguments are requested, the magnitude and phase of Xfft
%   are plotted in a new figure window.
% 
% Note:  To obtain an approximation of the Fourier series coefficients,
%        this fft should be multiplied by (2/N) where N is the length
%        of the time sequence.  No Scaling is applied by fft_easy.
%
% Matt Allen Spring 2005
% msallen@engr.wisc.edu
%
% TO DO:  Modify code to allow for arrays of > 3 dimensions
%

if length(ts) > 1;
    dt = ts(2)-ts(1);
    if abs(min(diff(ts)) - max(diff(ts)))/abs(max(diff(ts))) > 1e-6;
        error(['Time samples are not equally spaced, ',...
            'min(diff(ts))=',num2str(min(diff(ts))),',  max(diff(ts))=',num2str(max(diff(ts)))]);
    end
else
    dt = ts;
end

if nargin > 2
    DIM = varargin{1};
    if DIM == 2;
        xt = xt.';
    end
else
    DIM = [];
end
if (isempty(DIM) || nargin < 3) && size(xt,3) == 1;
    [a,b] = size(xt);
    if b > a;
        xt = xt.';
    end
end

% The time sequences are now the columns of xt.
N = size(xt,1);

Xfft = fft(xt,[],1);
Xfft = Xfft(1:(N/2+1),:,:);
% Create Frequency vector in rad/s
w1 = 2*pi/(N*dt);
ws = (0:w1:w1*N/2).';

if ~isempty(varargin)
    DIM = varargin{1};
    if DIM == 2;
        Xfft = Xfft.';
    end
end

if nargout < 1;
    if nargin > 3
        figure(varargin{2})
    else
        figure
    end
    ht = subplot(3,1,1:2);
    semilogy(ws/2/pi,abs(Xfft)); grid on;
    set(get(gca,'Children'),'LineWidth',2);
    title('FFT(x)');
    xlabel('Frequency (Hz)'); ylabel('|FFT(x)|');
    subplot(3,1,3)
    plot(ws/2/pi,angle(Xfft)*180/pi); grid on;
    set(get(gca,'Children'),'LineWidth',2);
    xlabel('Frequency (Hz)'); ylabel('Phase (FFT(x)) (^o)');
    axes(ht);
end
    


% --- Executes on button press in addOffsetTag.
function addOffsetTag_Callback(hObject, eventdata, handles)
% hObject    handle to addOffsetTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of addOffsetTag

data = get(handles.figure1, 'UserData');
data.addOffset = round(get(hObject,'Value'));
set(handles.figure1, 'UserData',data);
